'''Our imports and global statments'''
import es, gamethread, math
Players = {}
info = es.AddonInfo()
info.name = 'Adrenaline'
info.version = '0.71'
info.url = 'http://addons.eventscripts.com/addons/view/adren'
info.basename = 'adren'
info.author = 'J3ff Hoogland'
es.ServerVar('adren_version',info.version,'Adrenaline By: J3ff Hoogland').makepublic()
def Player(userid):
    '''Handels our player calls so we never get key errors when adding to our player's keys'''
    userid = int(userid)
    if userid not in Players:
        '''This makes it so Player(<userid>)[0] will be their adren. score and Player(<useird>)[1] will be their delays and Player(<userid>)[2] will be speed'''
        Players[userid] = [0.0, 0, 1]
    return Players[userid]
def Adrenaline(userid, amount, time):
    '''Used to assign players Adrenaline'''
    adren = Player(userid)[0]
    if adren+amount <= 1.0:
        Player(userid)[0] = adren+amount
        Delay(userid, time, AdrenalineDown, (userid, amount))
        Speed(userid, amount/2)
def AdrenalineDown(userid, amount):
    '''Used to reduce a player's adren'''
    adren = Player(userid)[0]
    if adren >= amount:
        Player(userid)[0] = adren-amount
        Speed(userid, (amount/2)*(-1))
    else:
        Player(userid)[0] = 0
        Speed(userid, 1, 'set')
def Delay(userid, time, callback, args):
    '''Handels our delay calls so they cancel on user death/round end'''
    delays = Player(userid)[1]
    delays += 1
    gamethread.delayedname(time, '%s_%s'%(userid, delays), callback, args)
def load():
    '''Is Run when the mod is loaded, we use noisy events so turn on noisy'''
    HudHint()
    es.doblock('corelib/noisy_on')
    es.server.queuecmd('est_RegEventBlock player_hurt "es_xdoblock adren/prep_hurt"')
def unload():
    '''Run when mod is unloaded, we used noisy events so it is polite to turn it off when we are done'''
    es.doblock('corelib/noisy_off')
    gamethread.cancelDelayed('HudHint')
    round_end({})
    es.server.queuecmd('est_UnRegEventBlock player_hurt "es_xdoblock adren/prep_hurt"')
def GetEVI(info):
    '''Wraps up having to turn GEI into local python vars'''
    es.ServerVar('_temp_var').set(0)
    es.server.cmd('est_GetEventInfo _temp_var %s'%info)
    try:
        return int(es.ServerVar('_temp_var'))
    except:
        return str(es.ServerVar('_temp_var'))
def SetEVI(info, value):
    '''To make setting EVIs pretty'''
    es.server.queuecmd('est_SetEventInfo %s %s'%(info, value))
def HudHint():
    for userid in es.getUseridList():
        adren = Player(userid)[0]
        es.usermsg('create','hudhint','HintText')
        es.usermsg('write','short','hudhint',-1)
        es.usermsg('write','string','hudhint','Adrenaline: %s'%adren)
        es.usermsg('send','hudhint',userid)
        es.usermsg('delete','hudhint')
    gamethread.delayedname(.5, 'HudHint', HudHint)
def player_disconnet(ev):
    '''Removes the player from our dict. if they are in it'''
    userid = int(ev['userid'])
    if userid in Players:
        del Players[userid]
def round_end(ev):
    '''We stop all delays for a user when the round ends'''
    for id in es.getUseridList():
        delay = Player(id)[1]
        while delay > 0:
            gamethread.cancelDelayed('%s_%s'%(id, delay))
            delay -= 1
def player_spawn(ev):
    '''Reset a user's adren. score when they spawn'''
    Player(ev['userid'])[0] = 0.0
def range(start=0, stop=0, step=1):
    '''My range fn, cause the built in one blows'''
    if not stop:
        stop = start
        start = 0
    mylist = []
    while start < stop:
        mylist.append(start)
        start += step
    return mylist
'''Bonuses from having adren.
    Take Reduced Damage equal to 50%*Adren Score (Example: Damage = 24, Adren Score = .5 - Damage reduced by 6)
    Move quicker, speed boost equalto half adren score
    Jump farthur.'''
def prep_hurt():
    '''Fires just before player hurt so we can hook damage if we need to'''
    userid = GetEVI('userid')
    if Player(userid):
        damage = GetEVI('dmg_health')
        hookdmg = (damage/2)*Player(userid)[0]
        #es.msg('Starting Damage - %s - Adren - %s - Hooking %s Damage due to adren'%(damage, Player(userid)[0], hookdmg))
        health = GetEVI('health')
        es.setplayerprop(userid, 'CBasePlayer.m_iHealth', health+hookdmg)
        SetEVI('health', health+hookdmg)
        SetEVI('dmg_health', damage-hookdmg)
def Speed(userid, amount, kind=None):
    '''Adds the givin amount to a user's movement speed'''
    if not kind:
        Player(userid)[2] += amount
        es.setplayerprop(userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', Player(userid)[2])
    else:
        Player(userid)[2] = amount
        es.setplayerprop(userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', Player(userid)[2])
    #es.msg('%s has speed for %s - speed var %s'%(es.getplayername(userid), es.getplayerprop(userid, 'CBasePlayer.localdata.m_flLaggedMovementValue'), Player(userid)[2]))
def player_jump(event_var):
    '''Long Jump code taken from SD'''
    userid = int(event_var['userid'])
    temp_multiplier = Player(userid)[0]/2
    es.setplayerprop(userid, 'CBasePlayer.localdata.m_vecBaseVelocity', '%s,%s,%s' % tuple([es.getplayerprop(userid, 'CBasePlayer.localdata.m_vecVelocity[%s]' % x) * temp_multiplier for x in range(3)]))
'''Things that give adren.
    Being within 10 feet of a gun being shot +01% (2 Second)
    Getting Blinded +10% (Expires over Duration of Flash)
    Getting hit by a bullet or hitting some +03% (Expires over 6 Seconds[knife hit doubles duration])
    Being within 20 feet of an exploding grenade +05% (Expires over 10 Seconds)
    Killing Someone +10% (Expires over 10 seconds[knife kill doubles duration])'''
def weapon_fire(ev):
    '''Runs everytime a player fires a weapon'''
    if ev['weapon']  != 'knife':
        x1,y1,z1 = es.getplayerlocation(ev['userid'])
        for id in es.getUseridList():
            x2,y2,z2 = es.getplayerlocation(id)
            if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 120:
                Adrenaline(id, .01, 2)
def player_hurt(ev):
    '''Runs when ever anyone takes damage'''
    for i in range(1, 4, 1):
        Adrenaline(ev['userid'], .01, i)
    if ev['weapon'] != 'knife':
        for i in range(1, 4, 1):
            Adrenaline(ev['attacker'], .01, i)
    else:
        for i in range(2, 8, 2):
            Adrenaline(ev['attacker'], .01, i)
def player_death(ev):
    '''Runs when someone dies'''
    if ev['weapon'] != 'knife':
        for i in range(1, 11, 1):
            Adrenaline(ev['attacker'], .01, i)
    else:
        for i in range(2, 22, 2):
            Adrenaline(ev['attacker'], .02, i)
def player_blind(ev):
    '''Runs when a player gets hit by a flash bang'''
    duration = int(es.getplayerprop(ev['userid'], "CCSPlayer.m_flFlashDuration"))
    start = duration*2
    while duration >= .5:
        Adrenaline(ev['userid'], .1/start, duration)
        duration -= .5
def hegrenade_detonate(ev):
    '''Runs when a grenade blows up'''
    x1, y1, z1 = int(float(ev['x'])), int(float(ev['y'])), int(float(ev['z']))
    for userid in es.getUseridList():
        x2, y2, z2 = es.getplayerlocation(userid)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 240:
            for i in range(2, 12, 2):
                Adrenaline(userid, .01, i)